import QtQuick 1.1
import Widgets 0.1

MouseArea {
    id: edgeSwipeArea

    anchors {
        top: if (edge != "bottom") return parent.top
        bottom: if (edge != "top") return parent.bottom
        right: if (edge != "left") return parent.right
        left: if (edge != "right") return parent.left
    }
    width: if (edge == "left" || edge == "right") return size
    height: if (edge == "top" || edge == "bottom") return size

    property string edge: "left"
    property real dragAmount: (edge == "top" || edge == "bottom") ? Math.abs(draggedItem.y) : Math.abs(draggedItem.x)
    property real size: units.dp(20/1.5)
    property real swipedThreshold: units.dp(50/1.5)
    property bool swiping: drag.active
    signal swiped

    onDragAmountChanged: if (dragAmount > swipedThreshold) swiped()

    drag {
        target: Item {id: draggedItem}
        axis: (edge == "top" || edge == "bottom") ? Drag.YAxis : Drag.XAxis
        onActiveChanged: {
            if (!drag.active) {draggedItem.x = 0; draggedItem.y = 0}
        }
    }
}
