import QtQuick 1.1
import Widgets 0.1

Item {
    id: revealingRectangle

    property int orientation: Qt.Vertical
    property int direction: Qt.LeftToRight

    Revealer {
        id: revealer
        
        target: showable
        width: target.width
        height: target.height
        x: orientation == Qt.Vertical ? 0 : direction == Qt.LeftToRight ? 0 : parent.width - width
        y: orientation == Qt.Horizontal ? 0 : direction == Qt.LeftToRight ? 0 : parent.height - height
        handleSize: orientation == Qt.Vertical ? handle.height : handle.width
        hintDisplacement: handleSize
        orientation: revealingRectangle.orientation
        direction: revealingRectangle.direction
    }
    
    Showable {
        id: showable
        
        width: orientation == Qt.Horizontal ? units.dp(100) : parent.width
        height: orientation == Qt.Vertical ? units.dp(100) : parent.height
        
        shown: false
        showAnimation: SmoothedAnimation {
            property: orientation == Qt.Horizontal ? "x" : "y"
            velocity: revealer.dragVelocity
            duration: 200
            to: revealer.openedValue
        }
        hideAnimation: SmoothedAnimation {
            property: orientation == Qt.Horizontal ? "x" : "y"
            velocity: revealer.dragVelocity
            duration: 200
            to: revealer.closedValue
        }
        
        Rectangle {
            anchors.fill: parent
            color: "red"
        }
        
        Rectangle {
            id: handle

            x: orientation == Qt.Vertical ? 0 : direction == Qt.LeftToRight ? parent.width - width : 0
            y: orientation == Qt.Horizontal ? 0 : direction == Qt.LeftToRight ? parent.height - height : 0
            width: orientation == Qt.Horizontal ? units.dp(15) : parent.width
            height: orientation == Qt.Vertical ? units.dp(15) : parent.height
            color: "black"
        }
    }
}
